﻿using ZWave.BasicApplication.Enums;
using ZWaveController.ViewModels;

namespace ZWaveController.Commands
{
    public class AssociationGetCommand : AssociationCommandBase
    {
        public AssociationGetCommand(AssociationModel associationViewModel)
            : base(associationViewModel)
        {
            IsTargetSensitive = true;
            Text = "Get Associations";
            SetCanExecute(param => MainVM.Controller != null && AssociationModel.SelectedGroup != null);
        }

        public override CommandTypes CommandType
        {
            get { return CommandTypes.CmdZWaveSendData; }
        }

        protected override void ExecuteInner(object parameter)
        {
            Log("Get Association started.");
            var node = AssociationModel.SelectedGroup.ParentDevice.Device;
            byte groupId = AssociationModel.SelectedGroup.Id;
            MainVM.LastCommandExecutionResult = MainVM.ControllerModel.AssociationGet(node, groupId);
        }
    }
}
