﻿using ZWave.BasicApplication.Enums;
using ZWave.CommandClasses;
using ZWaveController.ViewModels;

namespace ZWaveController.Commands
{
    public class AssociationGetCommandListCommand : AssociationCommandBase
    {
        public AssociationGetCommandListCommand(AssociationModel associationViewModel)
            : base(associationViewModel)
        {
            IsTargetSensitive = true;
            Text = "Get Association Group Info";
            SetCanExecute(param => MainVM.Controller != null &&
                AssociationModel.SelectedGroup != null &&
                Controller.Network.HasCommandClass(AssociationModel.SelectedGroup.ParentDevice.Device, COMMAND_CLASS_ASSOCIATION_GRP_INFO.ID));
        }

        public override CommandTypes CommandType
        {
            get { return CommandTypes.CmdZWaveSendData; }
        }

        protected override void ExecuteInner(object parameter)
        {
            Log("Get Association Group Info started.");
            AssociationModel.ExpandObject = AssociationModel.SelectedGroup;
            MainVM.LastCommandExecutionResult = MainVM.ControllerModel.AssociationGetCommandList(AssociationModel.SelectedGroup.ParentDevice.Device, AssociationModel.SelectedGroup.Id);
        }
    }
}
