﻿using ZWave.BasicApplication.Enums;
using ZWaveController.ViewModels;

namespace ZWaveController.Commands
{
    public class SetDefaultCommand : NetworkManagamentCommandBase
    {
        protected const byte BASIC_TYPE_ROUTING_SLAVE = 0x04;
        protected const byte BASIC_TYPE_STATIC_CONTROLLER = 0x02;
        protected const byte BASIC_TYPE_CONTROLLER = 0x01;

        public SetDefaultCommand(NetworkManagementViewModel nmViewModel)
            : base(nmViewModel)
        {
            Text = "Set Default";
            SetCanExecute(param => MainVM.Controller != null);
        }

        protected override bool CanCancelInner(object parameter)
        {
            return false;
        }

        public override CommandTypes CommandType
        {
            get { return CommandTypes.CmdZWaveSetDefault; }
        }

        protected override void ExecuteInner(object parameter)
        {
            MainVM.ControllerModel.SetDefault(out _token);
        }
    }
}
